// Agent participant in project contractNetProtocol

// gets the price for the product,
// a random value between 100 and 110.
price(_Service,X) :- .random(R) & X = (10*R)+100.

// the name of the agent playing initiator in the CNP
plays(initiator,contractor).

// send a message to the initiator introducing the
// agent as a participant 
+plays(initiator,In)
   :  .my_name(Me)
   <- .send(In,tell,introduction(participant,Me)).

// answer to Call For Proposal
@c1 +cfp(CNPId,Task)[source(A)]
   :  plays(initiator,A) & price(Task,Offer)
   <- // remember my proposal
      +proposal(CNPId,Task,Offer);
      .send(A,tell,propose(CNPId,Offer)).

// Handling an Accept message
@r1 +accept_proposal(CNPId)
		: proposal(CNPId,Task,Offer)
		<- .print("My proposal ‘", Offer,"' won CNP ",
							CNPId, " for ", Task, "!").
		// do the task and report to initiator
 
// Handling a Reject message
@r2 +reject_proposal(CNPId)
		<- .print("I lost CNP ",CNPId, ".");
		// clear memory
		-proposal(CNPId,_,_).